# Bootstrap this package from CVS.
-# Copyright (C) 2003, 2004 Free Software Foundation, Inc.
+# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
-# 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
# Written by Paul Eggert.
package=bison
+# Translation Project URL, for the registry of all projects.
+TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
+
# Ensure file names are sorted consistently across platforms;
# e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
+# Also, ensure diagnostics are in English, e.g., "wget --help" below.
LC_ALL=C
export LC_ALL
echo "$0: Bootstrapping CVS $package..."
-build_cvs_prefix() {
- CVS_PREFIX=:${1}:
- if [ "${2}" != - ]; then
- CVS_PREFIX=${CVS_PREFIX}${2}@
- fi
+cleanup_gnulib() {
+ status=$?
+ rm -fr gnulib
+ exit $status
}
# Get gnulib files.
if [ ! -d gnulib ]; then
echo "$0: getting gnulib files..."
- trap exit 1 2 13 15
- trap 'rm -fr gnulib; exit 1' 0
-
- case ${CVS_AUTH-anoncvs} in
- anoncvs)
- CVS_PREFIX='anoncvs@';;
+ case ${CVS_AUTH-pserver} in
+ pserver)
+ CVS_PREFIX=':pserver:anonymous@';;
ssh)
CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
*)
'') export CVS_RSH=ssh;;
esac
- cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
+ trap cleanup_gnulib 1 2 13 15
+
+ cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
+ cleanup_gnulib
- trap 0
+ trap - 1 2 13 15
fi
GNULIB_SRCDIR=gnulib
esac
<$GNULIB_SRCDIR/gnulib-tool || exit
gnulib_modules='
-alloca
argmatch
dirname
error
+extensions
getopt
+gettext
hard-locale
hash
malloc
quote
quotearg
stdbool
+stdio-safer
stpcpy
+strerror
+strtoul
+strverscmp
+unistd-safer
+unlocked-io
+verify
xalloc
xalloc-die
xstrndup
cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
done
+# This suppresses a bogus diagnostic
+# "warning: macro `AM_LANGINFO_CODESET' not found in library".
echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
sed '
/^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
# Get translations.
+get_translations() {
+ subdir=$1
+ domain=$2
+
+ echo "$0: getting translations into $subdir for $domain..."
+ (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&
+
+ $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&
+
+ sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
+ sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
+ awk -F. '
+ { if (lang && $1 != lang) print lang, ver }
+ { lang = $1; ver = substr($0, index($0, ".") + 1) }
+ END { if (lang) print lang, ver }
+ ' | awk -v domain="$domain" -v subdir="$subdir" '
+ {
+ lang = $1
+ ver = $2
+ urlfmt = ""
+ printf "$WGET_COMMAND -O %s/%s.po 'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", subdir, lang, lang, domain, ver, lang
+ }
+ END { print ":" }
+ ' | sh &&
+ ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
+ rm "$subdir/$domain.html"
+}
+
case $SKIP_PO in
'')
- echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
- (cd po &&
- rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
- wget -nv -nd -r -l 1 -A .po -C off \
- http://www2.iro.umontreal.ca/~gnutra/po/maint/$package/ &&
- ls *.po | sed 's/\.po$//' >LINGUAS
- ) || exit;;
+ case `wget --help` in
+ *'--no-cache'*)
+ no_cache='--no-cache';;
+ *'--cache=on/off'*)
+ no_cache='--cache=off';;
+ *)
+ no_cache='';;
+ esac
+
+ WGET_COMMAND="wget -nv $no_cache"
+ export WGET_COMMAND
+
+ get_translations po $package || exit
+
+ case $package in
+ bison)
+ get_translations runtime-po $package-runtime || exit
+ esac;;
esac
) >m4/gnulib.m4 || exit
(echo '# This file is generated automatically by "bootstrap".' &&
- $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules
+ $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules |
+ sed 's/^[ ]*AM_CPPFLAGS[ ]*+=/# (commented out by bootstrap) &/'
) >lib/gnulib.mk || exit
intl
m4/codeset.m4
m4/gettext.m4
+ m4/glibc2.m4
m4/glibc21.m4
m4/intdiv0.m4
m4/intmax.m4
echo $0: rm -fr $intl_files_to_remove ...
rm -fr $intl_files_to_remove || exit
-# Patch what appears to be a bug in gettext 0.14.1;
-# remove this once the bug is fixed.
-grep @top_builddir@ po/Makefile.in.in >/dev/null || {
- echo "$0: prepending 'top_builddir=@top_builddir@' to po/Makefile.in.in ... "
- old_contents=`cat po/Makefile.in.in` || exit
- cat >po/Makefile.in.in <<EOF
-top_builddir=@top_builddir@
-$old_contents
-EOF
-}
+# Undo changes to gnulib files that autoreconf made.
+for gnulib_file in $gnulib_files; do
+ test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
+ rm -f $gnulib_file &&
+ echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
+ cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
+ }
+done
# Put bug-reporting address into po/Makevars.
echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
+# Likewise for runtime-po/Makevars, except also change a few other parameters.
+sed '
+ s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
+ s/^\(subdir\) *=.*/\1 = runtime-po/
+ s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
+' <po/Makevars >runtime-po/Makevars
+
+# Copy identical files from po to runtime-po.
+(cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
# if src/parse-gram.[ch] are out of date, rebuild them.
parse_gram_y=`find src/parse-gram.y \